<?php
// Vytvoril Miroslav Novak www.platiti.cz
// Pouzivani bez souhlasu autora neni povoleno
// #Ver:PRV098-49-ga9cb64a5:2022-11-14#

require_once(DIR_FS_CATALOG."/UniModul/UniModul.php");


class uniadapter {
	var $code, $title, $description, $enabled, $payment;

	public $uniModul;

	private $configInfo; //nutne pro fci keys()
	private $gx_version;

	function __construct($uniModulName=null) {
		if ($uniModulName==null) {
			return;
		}
		BeginUniErr();

		require(DIR_FS_CATALOG . '/release_info.php');
		$this->gx_version = $gx_version;

		$uniFact = new UniModulFactory();
		$configInfo = $uniFact->getConfigInfo($uniModulName, $_SESSION["language_code"]);
		$this->configInfo = $configInfo;
		$configSetting = $this->getConfigData($configInfo, $uniModulName);
		$this->uniModul = $uniFact->createUniModul($uniModulName, $configSetting);

		global $order;
		$this->code = get_class($this); //$uniModulName;  // >><< LOW CASE


		$this->title = $this->uniModul->dictionary->get('payment_method_name', $_SESSION["language_code"]);
		$this->define($this->getShortConfigName('TEXT_TITLE'), $this->title);
		$this->description = $this->uniModul->dictionary->get('payment_method_name', $_SESSION["language_code"]);

		$this->sort_order = defined($this->getShortConfigName('SORT_ORDER')) ? constant($this->getShortConfigName('SORT_ORDER')) : 0;
		$this->enabled = (defined($this->getShortConfigName('STATUS')) && strtolower(constant($this->getShortConfigName('STATUS'))) == 'true') ? true : false;

		$this->order_status = 1; //????? MODULE_PAYMENT_PAYPAL_ORDER_STATUS_ID;

		if (is_object($order)) $this->update_status();

		//$this->email_footer = MODULE_PAYMENT_PAYU_TEXT_EMAIL_FOOTER;

		EndUniErr();
	}


	private function getConfigData($configInfo, $uniModulName) {
		$configData = array();
		foreach ($configInfo->configFields as $configField) {
			$cname = $this->getShortConfigName($configField->name, $uniModulName);
			$configData[$configField->name] = defined($cname) ? constant($cname) : null;
		}

		$uniModulConfig = new UniModulConfig();
		$uniModulConfig->mysql_server = DB_SERVER;
		$uniModulConfig->mysql_dbname = DB_DATABASE;
		$uniModulConfig->mysql_login = DB_SERVER_USERNAME;
		$uniModulConfig->mysql_password = DB_SERVER_PASSWORD;
		$uniModulConfig->uniModulDirUrl = (ENABLE_SSL ? HTTPS_SERVER : HTTP_SERVER) . DIR_WS_CATALOG . 'UniModul/';
		$uniModulConfig->adapterName = 'Gambio';

		//DB_PREFIX ..
		$cfgs = create_initialize_object('ConfigSetting', array('configData'=>$configData, 'uniModulConfig'=>$uniModulConfig));
		return $cfgs;
	}

	private function getShortConfigName($name, $uniModulName=null) {
		if ($uniModulName===null) {  // protoze pri konstrukci jeste uniModul neni dosazen
			$uniModulName = $this->uniModul->name;
		}
		$nn = 'MODULE_PAYMENT_'.$uniModulName . "BINDER_" . $name;
		//$nn = substr($nn, 0, 32);  // max omezeni na delku cfg itemu
		$nn = strtoupper($nn);
		return $nn;
	}

	private function getShortConfigNamePrefix($name, $uniModulName=null) {
		$nn = $this->getShortConfigName($name, $uniModulName);
		if ($this->gx_version >= 'v4.1') {
			$nn = 'configuration/' . $nn;
		}
		return $nn;
	}

	private function define($name, $value) {
		if (!defined($name)) define($name, $value);
	}

	// class methods
	function update_status() {
		BeginUniErr();
		global $db;
		global $order;

		if ( ($this->enabled == true) && ((int)constant($this->getShortConfigName("ZONE")) > 0) ) {
			$check_flag = false;
			$check = xtc_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . constant($this->getShortConfigName('SORT_ORDER')) . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
			while (!$check->EOF) {
				if ($check->fields['zone_id'] < 1) {
					$check_flag = true;
					break;
				} elseif ($check->fields['zone_id'] == $order->billing['zone_id']) {
					$check_flag = true;
					break;
				}
				$check->MoveNext();
			}

			if ($check_flag == false) {
				$this->enabled = false;
			}
		}
		EndUniErr();
	}

	function javascript_validation() {
		return false;
	}

	// funkce přidává radio buttonky pro výběr platebního modulu - asi pokud modul obsahuje podmoduly tak má smysl jich vložit víc
	function selection() {
		global $order;
		if (!$order) return null;
		BeginUniErr();
		$orderToPayInfo = $this->getOrderToPayInfo();
		$prePayGWInfo = $this->uniModul->queryPrePayGWInfo($orderToPayInfo);
		if ($prePayGWInfo->isPossible) {    //mohlo by to byt i v update_status

			$webRoot = str_replace('index.php?main_page=index','',xtc_href_link(FILENAME_DEFAULT, '', 'SSL'));
			$imgElm = "<img src='".$webRoot."includes/modules/payment/payu/payu.gif' alt='PayU'/> ";

			// TODO: Doplnit obrazek
			return EndUniErr(array('id' => $this->code,
				'module' => $this->uniModul->dictionary->get('payment_method_name', $_SESSION["language_code"]),
				'logo_url' => $this->uniModul->getModulSubMethodLogoImage2(),
			));
		} else {
			return EndUniErr(null);
		}
	}

	function pre_confirmation_check() {
		return false;
	}

	// ./includes/templates/template_default/templates/tpl_checkout_confirmation_default.php
	// Loaded automatically by index.php?main_page=checkout_confirmation.<br />
	// Displays final checkout details, cart, payment and shipping info details.
	function confirmation() {
		// ASI MUZE BYT FALSE - DLE DOKUMENTACE PAYPAL
		//return array('title' => MODULE_PAYMENT_PAYU_TEXT_DESCRIPTION.'XXXXX');
		return false;
	}



	// ./includes/templates/template_default/templates/tpl_checkout_confirmation_default.php
	// Functions to execute before finishing the form
	// Examples: add extra hidden fields to the form
	function process_button() {
		BeginUniErr();

		$orderToPayInfo = $this->getOrderToPayInfo();
		$prePayGWInfo = $this->uniModul->queryPrePayGWInfo($orderToPayInfo);
		if (!$prePayGWInfo->isPossible) {
			echo "This payment method cannot be used";  // nemelo by se sem vubec dostat, protoze se metoda ani nenabidne
			ResetUniErr();
			exit();
		}

        //echo "<input type='hidden' name='uniModul' value='". $this->uniModul->name."'>";
        echo "<input type='hidden' name='CheckoutButtonConfirmation' value='1'>";

		if ($prePayGWInfo->forexMessage!=null) {
			echo "<p>".$prePayGWInfo->forexMessage."</p>";
		}

		if ($prePayGWInfo->selectCsPayBrand) {
			echo '<p/><b>'.$this->uniModul->dictionary->get('ccBrand_title', $_SESSION["language_code"]).'</b><div style="padding-left:10ex">
				<input type="radio" name="brand" value="VISA" checked> VISA<br>
				<input type="radio" name="brand" value="MasterCard"> Master Card<br>
				<input type="radio" name="brand" value="VisaElectron"> Visa Electron<br>
				<input type="radio" name="brand" value="Maestro"> Maestro<br>
				</div><div style="clear:both"></div>';
		}





		EndUniErr();

		//return "\r\n".$formflds."\r\n";
		// form se da i vratit z funkce, ale echo je taky ok
	}


	private function getOrderToPayInfo() {
		global $order, $db;


		$order_currency = $order->info['currency'];
		if ($order_currency == "Kč") $order_currency = "CZK";
		$order_total = $order->info['total'] * $order->info['currency_value'];

		$description = "";
		foreach($order->products as $p ){
			if ($description != '') $description .= ", ";
			$description .= $p["name"];
		}


		$orderToPayInfo = new OrderToPayInfo();
		$orderToPayInfo->amount = $order_total;
		$orderToPayInfo->currency = $order_currency;
		$orderToPayInfo->language = $_SESSION["language_code"];
		$orderToPayInfo->description = $description;

		$customerData = new CustomerData();
		$customerData->first_name = $order->customer['firstname'];
		$customerData->last_name = $order->customer['lastname'] . ' ' . $customerData->last_name = $order->customer['company'];
		$customerData->email = $order->customer['email_address'];
		$customerData->phone = $order->customer['telephone'];
		$customerData->street = $order->customer['street_address']. ' '.$order->customer['suburb'];
		$customerData->city = $order->customer['city'];
		$customerData->post_code = $order->customer['postcode'];
		$customerData->country = $order->customer['country']['iso_code_2'];
		$orderToPayInfo->customerData = $customerData;


		$replyUrl = xtc_href_link(FILENAME_CHECKOUT_PROCESS, 'unireply=1', 'SSL');
		$orderToPayInfo->replyUrl = $replyUrl;
		//$orderToPayInfo->uniAdapterData = $_SESSION;

		return $orderToPayInfo;
	}


	function before_process() {
		BeginUniErr();
		if (!isset($_REQUEST["unireply"])) {
			$orderToPayInfo = $this->getOrderToPayInfo();
			$prePayGWInfo = $this->uniModul->queryPrePayGWInfo($orderToPayInfo);
			if (!$prePayGWInfo->isPossible) {
				echo "This payment method cannot be used";  // nemelo by se sem vubec dostat, protoze se metoda ani nenabidne
				ResetUniErr();
				exit();
			}
			$redirectAction = $this->uniModul->gatewayOrderRedirectAction($orderToPayInfo);

			if ($redirectAction->orderReplyStatus != null) {   // okamzita odpoved muze byt i zaroven s redirektem - napr. Cetelem
				$frontend_redir = $redirectAction->redirectUrl==null && $redirectAction->redirectForm==null;
				//$this->procesReplyStatus($redirectAction->orderReplyStatus, $frontend_redir);
			}
			if ($redirectAction->redirectForm != null) {
				$this->uniModul->formRedirect($redirectAction->redirectForm);
				ResetUniErr();
				exit();
			} else if ($redirectAction->redirectUrl != null) {
				header('Location: '.$redirectAction->redirectUrl);
				ResetUniErr();
				exit();
			}
		} else { // navrat z brany
			// KONTROLA ZE OK
			global $orderReplyStatus; // kvuli after_process
			$orderReplyStatus = $this->uniModul->gatewayReceiveReply($_SESSION["language_code"]);

			list($newState, $guiOk) = $this->getNewState($orderReplyStatus->orderStatus);

			if ($guiOk) {
				$this->transaction_id = $orderReplyStatus->gwOrderNumber; // Objevi se v hlavicce mailu pro provozovatele obchodu
				global $order;
				$order->info['order_status']=$newState;
			} else {
				$ertext = $this->getDict()['payment_failed'] . " ".$orderReplyStatus->resultText;
				$_SESSION['unimodul']['ertext'] = $ertext;
				ResetUniErr();
				xtc_redirect(xtc_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code . '&unierror=1', 'SSL', true, false));
			}
		}
		return EndUniErr(false);
	}

	function after_process() {
		BeginUniErr();

		global $insert_id;
		global $orderReplyStatus;

		$this->uniModul->updateShopOrderNumber($orderReplyStatus, $insert_id);

		return EndUniErr(false);
	}

	private function getNewState($orderStatus) {
		switch ($orderStatus) {
			case OrderStatus::$successful:
				$newState = constant($this->getShortConfigName('orderStatusSuccessfull'));
				$guiOk = true;
				break;
			case OrderStatus::$pending:
			case OrderStatus::$initiated:  // ? co jineho s takovou odpovedi
				$newState = constant($this->getShortConfigName('orderStatusPending'));
				$guiOk = true;
				break;
			case OrderStatus::$failedFinal:
				$newState = constant($this->getShortConfigName('orderStatusFailed'));
				$guiOk = false;   //?? nevim jak to nastavit pri neuspechu, takze asi newState zbytecny
				break;
			case OrderStatus::$failedRetriable;
			case OrderStatus::$invalidReply;
				$newState = null;
				$guiOk = false;
			default:
		}
		return array($newState, $guiOk);
	}



	function get_error() {
		BeginUniErr();
		if ($_GET['unierror']==1) {
			$error = array('title' => 'UNIMODUL' /*???nikde se to nepouzije*/,
			'error' => $_SESSION['unimodul']['ertext']);
			return EndUniErr($error);
		}
		EndUniErr();
	}

	function check() {
		BeginUniErr();
		if (!isset($this->uniModul)) return false; // preskocit uniadapter holy
		global $db;
		if (!isset($this->_check)) {
			if ($this->gx_version >= 'v4.1') {
				$check_query  = xtc_db_query("select `value` from " . TABLE_CONFIGURATION . " where `key` = '".$this->getShortConfigNamePrefix("STATUS")."'");
			} else {
				$check_query = xtc_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = '".$this->getShortConfigName("STATUS")."'");
			}
			$this->_check = xtc_db_num_rows($check_query);
		}
		return EndUniErr($this->_check);
	}

	/**
	* Build admin-page components
	*
	* @param int $zf_order_id
	* @return string
	*/
	function admin_notification($zf_order_id) {
		BeginUniErr();
		global $db;
		$output = '';
		$sql = "select * from " . TABLE_PAYU_TRANS . " where order_id = '" . $zf_order_id . "' and state = 1 order by date_paid";
		$lp_api = xtc_db_query($sql);
		if (xtc_db_num_rows($lp_api) > 0) {
			$output = "<td> <b style='color:green'>PayU</b><br/>
			Zaplaceno dne " . $lp_api->fields['date_paid']
			. "<br/>  PayU ORDERNUMBER je " . $lp_api->fields['payu_order_number'] . "</b><br/>"
			. $lp_api->fields['note'] ." </td>";
		}
		return EndUniErr($output);
	}

	function install() {
		BeginUniErr();
		global $db;

		if ($this->gx_version >= 'v4.1') {
			// specificka cfg pro eshop
			xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, sort_order, type, last_modified) values ('".$this->getShortConfigNamePrefix("STATUS")."', 'True', '1', 'switcher', now());");
			xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, sort_order, last_modified) values ('".$this->getShortConfigNamePrefix("SORT_ORDER")."','0', '0', now())");
			xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, sort_order, type, last_modified) values ('".$this->getShortConfigNamePrefix("ZONE")."', '0', '2', 'geo-zone', now())");
			xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, sort_order, last_modified) values ('".$this->getShortConfigNamePrefix("ALLOWED")."', '', '0', now())");
		} else {
			// specificka cfg pro eshop
			xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added) values ('".$this->getShortConfigName("STATUS")."', 'True', '6', '1', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now());");
			xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('".$this->getShortConfigName("SORT_ORDER")."','0', '6', '0', now())");
			xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, set_function, date_added) values ('".$this->getShortConfigName("ZONE")."', '0', '6', '2', 'xtc_get_zone_class_title', 'xtc_cfg_pull_down_zone_classes(', now())");
			xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('".$this->getShortConfigName("ALLOWED")."', '', '6', '0', now())");
		};


		// cfg z UniModulu
		foreach ($this->configInfo->configFields as $configField) {
			$fldname = $this->getShortConfigNamePrefix($configField->name);

			if ($configField->type == ConfigFieldType::$text) {
				if ($this->gx_version >= 'v4.1') {
					xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, sort_order, last_modified) values ('".$fldname."', '', '0', now())");
				} else {
					xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('".$fldname."', '', '6', '0', now())");
				}

			} else if ($configField->type == ConfigFieldType::$choice) {
				$opts = array();
				$cmt = '';
				foreach ($configField->choiceItems as $val=>$lab) {
					$opts[] = $val;
					$cmt .= ($cmt == '' ? '' : ', ') . $lab . " .. " . $val;
				}
				$opts_php = addslashes(var_export($opts, true));


				if ($this->gx_version >= 'v4.1') {
					//TODO výběr?
					xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, sort_order, last_modified) values ('".$fldname."', '', '0', now())");
				} else {
					xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added) values ('".$fldname."', 'True', '6', '1', 'xtc_cfg_select_option(".$opts_php.", ', now());");
				}


			} else if ($configField->type == ConfigFieldType::$orderStatus) {
				if ($this->gx_version >= 'v4.1') {
					xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, sort_order, type, last_modified) values ('".$fldname."', '0', '2', 'order-status', now())");
				} else {
					xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, use_function, date_added) values ('".$fldname."', '2', '6', '44', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
				}

			}
		}
		$sql = file_get_contents (DIR_FS_CATALOG . "/UniModul/UniModul.sql");
		xtc_db_query($sql);
		EndUniErr();
	}

	function remove() {
		BeginUniErr();
		if ($this->gx_version >= 'v4.1') {
			xtc_db_query("delete from " . TABLE_CONFIGURATION . " where `key` in ('" . implode("', '", $this->keys()) . "')");
		} else {
			xtc_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
		}
		EndUniErr();
	}

	function keys() {
		BeginUniErr();
		$ks = array($this->getShortConfigNamePrefix('STATUS'), $this->getShortConfigNamePrefix('ZONE'), $this->getShortConfigNamePrefix('SORT_ORDER'), $this->getShortConfigNamePrefix('ALLOWED'));
		foreach ($this->configInfo->configFields as $configField) {
			if (in_array($configField->type, array(ConfigFieldType::$text, ConfigFieldType::$choice, ConfigFieldType::$orderStatus))) {
				$ks[] = $this->getShortConfigNamePrefix($configField->name);

				// old style admin langs
				$fldname = $this->getShortConfigName($configField->name);
				$this->define($fldname.'_TITLE', $configField->label);
				if ($configField->type == ConfigFieldType::$choice) {
					$cmt = '';
					foreach ($configField->choiceItems as $val=>$lab) {
						$cmt .= ($cmt == '' ? '' : ', ') . $lab . " .. " . $val;
					}
					$this->define($fldname.'_DESC', $cmt);
				} else {
					$this->define($fldname.'_DESC', '&nbsp;');
				}

			}
		}

		// admin langs
		$dic = $this->getDict();
		$this->define($this->getShortConfigName("STATUS")."_TITLE", $dic['status']);
		$this->define($this->getShortConfigName("SORT_ORDER")."_TITLE", $dic['order']);
		$this->define($this->getShortConfigName("ZONE")."_TITLE", $dic['zone']);
		$this->define($this->getShortConfigName("ALLOWED")."_TITLE", $dic['allowed']);
		$this->define($this->getShortConfigName("ALLOWED")."_DESC", $dic['allowed_desc']);

		$this->define($this->getShortConfigName("STATUS")."_DESC", '&nbsp;');
		$this->define($this->getShortConfigName("SORT_ORDER")."_DESC", '&nbsp;');
		$this->define($this->getShortConfigName("ZONE")."_DESC", '&nbsp;');

		return EndUniErr($ks);
	}

	protected function getDict() {
			$dict = array(
				'en' => array (
					'payment_failed' => 'Your payment failed, please try again.',
					'status' => 'Enable Module',
					'zone' => 'Payment Zone',
					'order' => 'Display Sort Order',
					'allowed' => 'Allowed Zones',
					'allowed_desc' => 'Insert allowed zones (e.g. AT,DE). Leave blank to allow all zones.',
				),
				'de' => array (
					'payment_failed' => 'Ihre Zahlung ist fehlgeschlagen. Bitte versuchen Sie es erneut.',
					'status' => 'Zahlungsmodul aktivieren',
					'zone' => 'Zahlungszone',
					'order' => 'Anzeigereihenfolge',
					'allowed' => 'Erlaubte Zonen',
					'allowed_desc' => 'Zulässige Zonen einfügen (z. B. AT, DE). Lassen Sie das Feld leer, um alle Zonen zuzulassen.',
			),
				'cs' => array (
					'payment_failed' => 'Platba se nezdařila, pokuste se zaplatit znovu.',
					'status' => 'Povolit modul',
					'zone' => 'Zóna platby',
					'order' => 'Pořadí zobrazení',
					'allowed' => 'Povolené zóny',
					'allowed_desc' => 'Vložte povolené zóny (např. AT, DE). Nechte prázdné pro všechny zóny.',
				),
				'sk' => array (
					'payment_failed' => 'Platba zlyhala, pokúste sa zaplatiť znova.',
					'status' => 'Povoliť modul',
					'zone' => 'Zóna platby',
					'order' => 'Poradie zobrazenia',
					'allowed' => 'Povolené zóny',
					'allowed_desc' => 'Vložte povolené zóny (napr. AT, DE). Ponechajte prázdne pre všetky zóny.',
				),
				'hu' => array (
					'payment_failed' => 'A fizetés sikertelen, próbálkozzon újra.',
					'status' => 'Modul engedélyezése',
					'zone' => 'Fizetési zóna',
					'order' => 'Megjelenítési sorrend',
					'allowed' => 'Engedélyezett zónák',
					'allowed_desc' => 'Helyezze be az engedélyezett zónákat (pl. AT, DE). Az összes zóna engedélyezéséhez hagyja üresen.',
				),
				'ro' => array (
					'payment_failed' => 'Plata dvs. a eșuat, vă rugăm să încercați din nou.',
					'status' => 'Activați modulul',
					'zone' => 'Zona de plată',
					'order' => 'Afișează ordinea',
					'allowed' => 'Zone permise',
					'allowed_desc' => 'Introduceți zonele permise (de ex. AT, DE). Lăsați necompletat pentru a permite toate zonele.',
				),
		);
		$dic = isset($dict[$_SESSION["language_code"]]) ? $dict[$_SESSION["language_code"]] : $dict["en"];
		return $dic;
	}

}
